# Import the modules that we need in this script
from __future__ import division
from psychopy import core, visual, event

# Create a window to draw in
win = visual.Window(
        size=(1, 1),
        color=(-1, -1, -1),
        fullscr=True,
        units='norm')  # you don't have to use new lines for each attribute, but sometime it's easier to read that way

# An image using ImageStim.
image = visual.ImageStim(win,
    image='dogface.jpg',
    mask=None,
    pos=(0.0, 0.0),
    size=(.852, 1.272),
    ori=1)

# Initiate clock to keep track of time
clock = core.Clock()
while clock.getTime() < 20 and not event.getKeys(keyList=['escape','q']):  # until response or timeout

    image.ori *= 1.01  # Accelerating orientation (1% on every frame)
    image.size -= 0.001  # Decrease size uniformly on x and y
    if image.opacity >= 0:  # attributes can be referenced
        image.opacity -= 0.001  # Decrease opacity

    # Show the result of all the above
    image.draw()
    win.flip()